* Get the name of the file to "de-convert". Exit if none was selected.

close databases
lcIN_FILE = getfile('SCX|PJX', 'Select file to convert to 2.0:', 'Convert')
if empty(lcIN_FILE)
	return
endif empty(lcIN_FILE)

* Get the file type (the extension) and a default file name.

lcTYPE     = substr(lcIN_FILE, at('.', lcIN_FILE) + 1)
lcOUT_FILE = 'NEWFILE.' + lcTYPE

* As long as the user hasn't changed the name of the output file, get the
* filename to use. Give an error if the same name used.

do while .T.
	lcOUT_FILE = putfile('File to create:', lcOUT_FILE, lcTYPE)
	if lcOUT_FILE = lcIN_FILE
		wait window 'Please enter a different name for the file to create.'
	else
		exit
	endif lcOUT_FILE = lcIN_FILE
enddo while .T.

* Exit if no output file was selected.

if empty(lcOUT_FILE)
	return
endif empty(lcOUT_FILE)
wait window 'Converting to FoxPro 2.0 format ...' nowait
if lcTYPE = 'PJX'

* For a project file, create a temporary file with the structure of a 2.0
* project. Then create the output file with that structure.

	use (lcIN_FILE)
	lcIN_ALS = alias()
	lcTEMP   = sys(3) + '.DBF'
	lcSTRU   = sys(3)
	copy structure extended to (lcTEMP)
	select 0
	create table (lcSTRU) (FIELD_NAME C(10), FIELD_TYPE C(1), FIELD_LEN N(3), ;
		FIELD_DEC N(3), FIELD_POS N(2))
	append from (lcTEMP)
	erase (lcTEMP)
	replace all FIELD_POS with recno()
	go top
	replace FIELD_TYPE with 'C', FIELD_LEN with 129
	locate for FIELD_NAME = 'ARRANGED'
	replace FIELD_TYPE with 'L', FIELD_LEN with 1
	locate for FIELD_NAME = 'CMNTSTYLE'
	lnPOS = recno()
	replace rest FIELD_POS with FIELD_POS + 2
	insert into (lcSTRU) values ('SCRNROW', 'N', 3, 0, lnPOS)
	insert into (lcSTRU) values ('SCRNCOL', 'N', 3, 0, lnPOS + 1)
	index on FIELD_POS tag FIELD_POS
	copy to (lcTEMP) fields FIELD_NAME, FIELD_TYPE, FIELD_LEN, FIELD_DEC
	use
	erase (lcSTRU + '.DBF')
	erase (lcSTRU + '.CDX')
	create (lcOUT_FILE) from (lcTEMP)
	lcOUT_ALS = alias()
	erase (lcTEMP)

* Now copy all of the records from the 2.5 file to the 2.0 file (can't use
* APPEND FROM, since NAME is being changed from Memo to Char).

	select (lcIN_ALS)
	scan
		scatter memvar memo
		ARRANGED = not empty(ARRANGED)
		SCRNROW  = iif(M.ARRANGED, val(substr(ARRANGED, 17, 2)), 0)
		SCRNCOL  = iif(M.ARRANGED, val(substr(ARRANGED, 25, 2)), 0)
		insert into (lcOUT_ALS) from memvar
	endscan
	close databases
else

* For a screen file, create a temporary file with the structure of a 2.0
* screen. Then create the output file with that structure.

	use (lcIN_FILE)
	lcIN_ALS = alias()
	lcTEMP   = sys(3)
	lcSTRU   = sys(3)
	copy to (lcTEMP + '.SCX')
	use (lcTEMP + '.SCX')
	replace OBJCODE with 10
	delete for PLATFORM <> 'DOS'
	copy structure extended to (lcSTRU)
	use (lcSTRU) exclusive
	go top
	delete next 3
	locate for FIELD_NAME = 'OBJCODE'
	replace FIELD_LEN with 2
	locate for FIELD_NAME = 'VPOS'
	replace next 2 FIELD_LEN with 4, FIELD_DEC with 0
	skip
	replace next 2 FIELD_LEN with 3, FIELD_DEC with 0
	locate for FIELD_NAME = 'PENRED'
	delete next 18
	locate for FIELD_NAME = 'SPACING'
	replace FIELD_LEN with 3, FIELD_DEC with 0
	skip
	delete
	pack
	use
	create (lcOUT_FILE) from (lcSTRU)
	lcOUT_ALS = alias()
	erase (lcSTRU)

* Now copy all of the records from the 2.5 file to the 2.0 file.

	append from (lcTEMP + '.SCX')
	erase (lcTEMP + '.SCX')
	erase (lcTEMP + '.SCT')
	close databases
endif lcTYPE = 'PJX'
wait clear
